﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Body1 : MonoBehaviour {

	private Rigidbody2D mybody;
	public Rigidbody2D MyRigidBody
	{
		get { 
			if ( mybody == null ) 
				mybody = GetComponent<Rigidbody2D>();

			return mybody;
		}
	}
	
	public virtual void OnCollisionEnter2D(Collision2D coll)
    {
        MyRigidBody.velocity = Vector2.zero;
    }
 
	public virtual void OnCollisionStay2D(Collision2D coll)
    {
        //MyRigidBody.velocity = Vector2.zero;
    }
 
    private Vector3 _lastVelocity;
	private ContactPoint2D[] contacts = new ContactPoint2D[20]; 

    void FixedUpdate()
    {
          // Apply the final velocity
        _lastVelocity = GetCurrentVelocity();
        MyRigidBody.velocity = _lastVelocity;
 
        int contactCount = MyRigidBody.GetContacts(contacts);
        if ( contactCount > 0 )
        {
            Debug.LogFormat("Contact count: {0}", contactCount);
            MyRigidBody.velocity = Vector3.zero;
        }

        Debug.LogFormat("Velocity: {0} | {1}", _lastVelocity, MyRigidBody.velocity);
	}

	public Vector3 GetCurrentVelocity()
	{
        var velocity = Vector3.down;
        //Debug.LogFormat("Horizontal: {0}", Input.GetAxis("Horizontal"));
		return velocity + Vector3.right * Input.GetAxis("Horizontal") * 5f;
	}
}
